<?php
/* DA/efg_firewall.inc
 *    PHP include script for efg.php,
 *    intended to show/deliver the actual firewall script
 *
 * 2014-03-28 v2.0.3 Added dictionary attack prevention in INPUT Chain
 * 2014-03-27 v2.0.2 Added $MY_CIDR
 * 2014-03-22 v2.0.1 Added SYNACKANDNEW in bad_tcp_packets chain
 * 2014-03-18 v2.0.0 Released
 * 2014-02-27 v2.0.0 Started -AK
 *
 * TAB=3
 *
 * @category Net
 * @version $Id: DA/efg_firewall.inc, v2.0.3 2014-03-28
 * @author Alex KEMP http://www.modem-help.co.uk/
 * @translator Alex KEMP http://translate.google.co.uk/
 *
 * (START original header)
 * Copyright 2002 Timothy Scott Morizot
 *
 * This file is part of my Easy Firewall Generator for IPTables.
 *
 * Easy Firewall Generator for IPTables is free software;
 * you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Easy Firewall Generator for IPTables is distributed
 * in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * in this distribution; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * (next line now set by Conteg)
 * //Set type to plain text
 * header("Content-Type: text/plain");
 * (FINISH original header)
 *
 * script transcribed to avoid use of untested '$_POST()' variables
 */

?>
#!/bin/sh
#
###############################################################################
#
# Dannet iptables firewall script til Linux 2.4, 2.6 + senere kerne
<?php
	print "# Script genereret af Easy Firewall Generator til IPTables $VERSION
# (v2.0.0 direkte baseret på original EFG v1.17)
# Denne version      : ophavsret $YEAR_NOW Modem-Help, Ltd. ($HOME)
# Oversættelse (DA)  : ophavsret $YEAR_NOW Modem-Help, Ltd.
# Tidligere versioner: ophavsret 2002 Timothy Scott Morizot (easyfwgen.morizot.net)
#
# Dannet             : $NOW
";
?>
#
# Redhat chkconfig kommentarer - firewall anvendes tidligt,
#                                fjernet sent
# chkconfig: 2345 08 92
# beskrivelse: Dette script Anvender eller fjerner iptables firewall-regler
#
# Indstillinger, der bruges:
<?php
	print "# INET_IFACE: $INET_IFACE
# InternetIP: ". (( $DYNAMIC_IP )
	? $DYNAMIC_IP_YES_TITLE[ $_LANG ]
	: "{$DYNAMIC_IP_NO_TITLE[$_LANG]} ($INET_ADDRESS)"
) ."
#   Computer: ". (( $GATEWAY )
	? "{$GATEWAY_YES_TITLE[$_LANG]}
#             LOCAL_IFACE: $LOCAL_IFACE
#                LOCAL_IP: $LOCAL_IP
#               LOCAL_NET: $LOCAL_NET
#             LOCAL_BCAST: $LOCAL_BCAST"
	: $GATEWAY_NO_TITLE[ $_LANG ]
) ."
#    netværk: ". (( $SPECIAL_LAN )
	? (
		( $BLOCK_OUTBOUND )		? "({$BLOCK_OUTBOUND_TITLE[$_LANG]})"		: '').
		(( $INTERNAL_DHCP )		? "({$INTERNAL_DHCP_TITLE[$_LANG]})"		: '').
		(( $MANGLE_TTL )			? "({$MANGLE_TTL_TITLE[$_LANG]})"			: '').
		(( $PORT_FORWARD )		? "({$PORT_FORWARD_TITLE[$_LANG]})"			: '').
		(( $TRANSPARENT_PROXY )	? "({$TRANSPARENT_PROXY_TITLE[$_LANG]})"	: ''
	)
	: '(ingen)'
) ."
#  Tillad In: ". (( $INBOUND_ALLOW )
	? (
		( $SELF_IN )				? "({$SELF_NET_TITLE[$_LANG]})"				: '').
		(( $DHCP_IN )				? "({$DHCP_IN_TITLE[$_LANG]})"				: '').
		(( $DNS_IN )				? "({$DNS_IN_TITLE[$_LANG]})"					: '').
		(( $IM_IN )					? "({$IM_IN_TITLE[$_LANG]})"					: '').
		(( $HTTP_IN )				? "({$HTTP_IN_TITLE[$_LANG]})"				: '').
		(( $FTP_IN )				? "({$FTP_IN_TITLE[$_LANG]})"					: '').
		(( $EMAIL_IN )				? "({$EMAIL_IN_TITLE[$_LANG]})"				: '').
		(( $NTP_IN )				? "({$NTP_IN_TITLE[$_LANG]})"					: '').
		(( $MDNSRESPONDER_IN )	? "({$MDNSRESPONDER_IN_TITLE[$_LANG]})"	: '').
		(( $MESSENGER_IN )		? "({$MESSENGER_IN_TITLE[$_LANG]})"			: '').
		(( $NFS_IN )				? "({$NFS_IN_TITLE[$_LANG]})"					: '').
		(( $OTHER_IN )				? "({$OTHER_IN_TITLE[$_LANG]})"				: '').
		(( $SSH_IN )				? "({$SSH_IN_TITLE[$_LANG]})"					: ''
	)
	: '(ingen)'
) ."
#    Fireparse: ". (( $LOG_FIREPARSE )
	? 'Ja'
	: 'Nej'
) ."
#     IRC User: ". (( $IRC_USER )
	? 'Ja'
	: 'Nej'
) ."
# Dict stopper: ". (( $DICT )
	? 'Ja'
	: 'Nej'
). "\n";
?>
#
# Denne generator er primært designet til RedHat-installationer,
# selv om det skal kunne tilpasses til andre.
#
# Det kan udføres med den typiske start og stop argumenter.
# Hvis det bruges med stop, vil det stoppe efter skylning firewallen.
# De gemme og gendanne argumenter vil gemme eller gendanne regler fra
# /etc/sysconfig/iptables fil. De gemme og gendanne argumenter er medtaget
# for at bevare kompatibilitet med Redhat s eller Fedoras init.d script
# hvis du foretrækker at bruge det.

# Redhat / Fedora / CentOS monteringsvejledning
#
# 1. Har linket systemet de iptables init.d startup script i køre stater
#    2, 3, og 5.
#    chkconfig --level 235 iptables on
#
# 2. Gem dette script og udføre den til at indlæse regelsæt fra denne fil.
#    Du kan være nødt til at køre dos2unix kommando på den for at fjerne
#    linjeskift.
#
# 3. At have det anvendt ved opstart, skal du kopiere dette script til
#    /etc/init.d/iptables. Det accepterer stoppe, starte, gemme og gendanne
#    argumenter. (Du ønsker måske at redde den eksisterende først.)
#    Alternativt, hvis du udstede 'service iptables save' kommando init.d
#    scriptet skal redde de regler og genindlæse dem på runtime.
#
# 4. For ikke-Redhat systemer (eller Redhat systemer, hvis du har et problem),
#    kan du ønsker at føje kommandoen til at køre dette script til rc.local.
#    rc.local er typisk placeret i /etc og /etc/rc.d og er normalt den sidste
#    ting henrettet ved opstart. Du skal blot tilføje
#    /sti/til/script/SCRIPT_NAME på sin egen linje i rc.local fil.

###############################################################################
#
# Lokale Indstillinger
#

# sysctl placering. Hvis indstillet, vil den bruge sysctl at justere
# kerneparametrene. Hvis dette er sat til en tom streng (eller er frakoblet),
# brug af sysctl er deaktiveret.

SYSCTL="/sbin/sysctl -w"

# Hvis du vil gentage den værdi, direkte til /proc fil i stedet
# SYSCTL=""

# IPTables Placering - juster, hvis nødvendigt

IPT="/sbin/iptables"
IPTS="/sbin/iptables-save"
IPTR="/sbin/iptables-restore"

# Internet Interface
<?php
print "INET_IFACE=\"$INET_IFACE\"\n";
print ( $DYNAMIC_IP )
	? ''
	: "INET_ADDRESS=\"$INET_ADDRESS\"\n";
print ( $GATEWAY )
	? "
# Local Interface Information
LOCAL_IFACE=\"$LOCAL_IFACE\"
LOCAL_IP=\"$LOCAL_IP\"
LOCAL_NET=\"$LOCAL_NET\"
LOCAL_BCAST=\"$LOCAL_BCAST\"
"
	: '';
print ( $SELF_IN )
	? "
# Netværk Administrator Adgang
MY_CIDR=\"$SELF_NET\"
"
	: '';
?>

# Localhost Grænseflade

LO_IFACE="lo"
LO_IP="127.0.0.1"

# Gemme ('save') og gendanne ('restore') argumenter håndteres her
if [ "$1" = "save" ]
then
	echo -n "Lagring firewall til /etc/sysconfig/iptables ... "
	$IPTS > /etc/sysconfig/iptables
	echo "done"
	exit 0
elif [ "$1" = "restore" ]
then
	echo -n "Gendannelse firewall fra /etc/sysconfig/iptables ... "
	$IPTR < /etc/sysconfig/iptables
	echo "done"
	exit 0
fi

###############################################################################
#
# Load Moduler
#

echo "Loading kernemoduler ..."

# Du bør udkommenter linjen nedenfor og køre det første gang blot for at sikre,
# at alle kerne modul afhængigheder er OK. Der er ingen grund til at køre hver
# gang, dog.

# /sbin/depmod -a

# Medmindre du har kerne modul auto-loading deaktiveret, bør du ikke nødt til
# manuelt at indlæse hver af disse moduler. Andre end ip_tables, ip_conntrack,
# og nogle af de valgfrie moduler, jeg har forladt disse kommenteret som
# standard. Uncomment hvis du har nogen problemer, eller hvis du har
# deaktiveret modul autoload. Bemærk, at nogle moduler skal indlæses af en anden
# kernel modul.

# core netfilter modul
/sbin/modprobe ip_tables

# stateful sporing tilslutningsmodulet
/sbin/modprobe ip_conntrack

# filter bord modul
# /sbin/modprobe iptable_filter

# mangle bord modul
# /sbin/modprobe iptable_mangle

# NAT tabel modul
# /sbin/modprobe iptable_nat

# LOG target modul
# /sbin/modprobe ipt_LOG

# Dette bruges til at begrænse antallet af pakker per sekund / min / time
# /sbin/modprobe ipt_limit

# maskerade target modul
# /sbin/modprobe ipt_MASQUERADE

# filter ved hjælp ejer som en del af kampen
# /sbin/modprobe ipt_owner

# AFVIS mål falder pakken og returnerer en ICMP svar.
# Den reaktion kan konfigureres. Som standard tilslutning afvist.
# /sbin/modprobe ipt_REJECT

# Dette mål giver pakker skal mærkes i mangle tabellen
# /sbin/modprobe ipt_mark

# Dette mål påvirker TCP MSS
# /sbin/modprobe ipt_tcpmss

# Denne kamp tillader flere havne i stedet for en enkelt port eller et interval
# /sbin/modprobe multiport

# Denne kamp kontrol mod TCP flag
# /sbin/modprobe ipt_state

# Denne kamp fanger pakker med ugyldige flag
# /sbin/modprobe ipt_unclean

# Ftp NAT modul skal bruges til ikke-PASV ftp støtte
<?php
	print ( $FTP_OUT )
		? '#'
		: '';
?>
/sbin/modprobe ip_nat_ftp

# modulet fuld tilslutning sporing ftp
<?php
	print ( $FTP_OUT )
		? '#'
		: '';
?>
/sbin/modprobe ip_conntrack_ftp

# module full tilslutning SPORING ftp
<?php
	print ( $IRC_OUT )
		? '#'
		: '';
?>
/sbin/modprobe ip_conntrack_irc


###############################################################################
#
# Kernel Parameterkonfiguration
#
# Se http://ipsysctl-tutorial.frozentux.net/chunkyhtml/index.html for en
# detaljeret tutorial om sysctl og de forskellige indstillinger til rådighed.

# Nødvendig for at aktivere IPv4 videresendelse.
# Redhat brugere kan prøve at sætte FORWARD_IPV4 i /etc/sysconfig/network
# til true. Alternativt kan der indstilles i /etc/sysctl.conf
<?php
	print ( $GATEWAY )
		? "if [ \"\$SYSCTL\" = \"\" ]
then
    echo \"1\" > /proc/sys/net/ipv4/ip_forward
else
    \$SYSCTL net.ipv4.ip_forward=\"1\"
fi"
		: "#if [ \"\$SYSCTL\" = \"\" ]
#then
#    echo \"1\" > /proc/sys/net/ipv4/ip_forward
#else
#    \$SYSCTL net.ipv4.ip_forward=\"1\"
#fi";
?>


# Dette gør det muligt dynamisk adresse hacking.
# Det kan hjælpe, hvis du har en dynamisk IP-adresse (f.eks slip, ppp, DHCP).
#if [ "$SYSCTL" = "" ]
#then
#    echo "1" > /proc/sys/net/ipv4/ip_dynaddr
#else
#    $SYSCTL net.ipv4.ip_dynaddr="1"
#fi

# Dette gør det muligt SYN oversvømmelse beskyttelse.
# Den SYN cookies aktivering giver dit system til at acceptere et ubegrænset
# antal TCP-forbindelser og samtidig forsøgt at give en rimelig service under
# et denial of service angreb.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/tcp_syncookies
else
    $SYSCTL net.ipv4.tcp_syncookies="1"
fi

# Dette gør det muligt kildegodkendelsen ved omvendt sti i henhold til
# RFC1812. Med andre ord gjorde svarpakken stammer fra den samme
# grænseflade, hvorigennem kilden pakken blev sendt? Det anbefales for
# enkelt-homed systemer og routere på stub netværk. Da det er de
# konfigurationer denne firewall er designet til at understøtte, jeg
# tænder den som standard.
# Slå det fra, hvis du bruger flere NIC tilsluttet samme netværk.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/conf/all/rp_filter
else
    $SYSCTL net.ipv4.conf.all.rp_filter="1"
fi

# Denne indstilling giver et subnet skal firewalled med en enkelt IP-adresse.
# Det bruges til at bygge en DMZ. Da det ikke er et fokus for denne firewall
# script, er det ikke aktiveret som standard, men er medtaget som reference.
# Se også: http://www.sjdjweis.com/linux/proxyarp/
#if [ "$SYSCTL" = "" ]
#then
#    echo "1" > /proc/sys/net/ipv4/conf/all/proxy_arp
#else
#    $SYSCTL net.ipv4.conf.all.proxy_arp="1"
#fi

#De følgende kerne indstillinger blev foreslået af Alex Weeks. Tak!

# Denne kerne parameter instruerer kernen at ignorere alle ICMP
# ekkoforespørgsler sendes til broadcast-adresse. Dette forhindrer
# en række Smølferne og lignende DoS grimme angreb.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/icmp_echo_ignore_broadcasts
else
    $SYSCTL net.ipv4.icmp_echo_ignore_broadcasts="1"
fi

# Denne mulighed kan bruges til at acceptere eller afvise kilde dirigeres
# pakker. Det er normalt som standard aktiveret, men er generelt betragtes
# som en sikkerhedsrisiko. Denne indstilling slår det fra.
if [ "$SYSCTL" = "" ]
then
    echo "0" > /proc/sys/net/ipv4/conf/all/accept_source_route
else
    $SYSCTL net.ipv4.conf.all.accept_source_route="0"
fi

# Denne mulighed kan deaktivere ICMP omdirigeringer. ICMP redirects er generelt
# betragtes som en sikkerhedsrisiko og bør ikke være behov for de fleste
# systemer, der anvender denne generator.
#if [ "$SYSCTL" = "" ]
#then
#    echo "0" > /proc/sys/net/ipv4/conf/all/accept_redirects
#else
#    $SYSCTL net.ipv4.conf.all.accept_redirects="0"
#fi

# Men vil vi sikre secure_redirects mulighed er på stedet.
# Denne indstilling accepterer kun fra gateways i listen standardgateways.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/conf/all/secure_redirects
else
    $SYSCTL net.ipv4.conf.all.secure_redirects="1"
fi

# Denne indstilling logger pakker fra umulige adresser.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/conf/all/log_martians
else
    $SYSCTL net.ipv4.conf.all.log_martians="1"
fi


###############################################################################
#
# Skyl ikke eksisterende regler eller kæder
#

echo "Flushing Tabeller ..."

# Nulstil Standardpolitikker
$IPT -P INPUT ACCEPT
$IPT -P FORWARD ACCEPT
$IPT -P OUTPUT ACCEPT
$IPT -t nat -P PREROUTING ACCEPT
$IPT -t nat -P POSTROUTING ACCEPT
$IPT -t nat -P OUTPUT ACCEPT
$IPT -t mangle -P PREROUTING ACCEPT
$IPT -t mangle -P OUTPUT ACCEPT

# Skyl alle regler
$IPT -F
$IPT -t nat -F
$IPT -t mangle -F

# Slette alle ikke-standard kæder
$IPT -X
$IPT -t nat -X
$IPT -t mangle -X

if [ "$1" = "stop" ]
then
	echo "Firewall helt tømte! Nu kører uden firewall."
	exit 0
fi

###############################################################################
#
# Regler Configuration
#

###############################################################################
#
# Filter Table
#
###############################################################################

# Angive Politikker

$IPT -P INPUT DROP
$IPT -P OUTPUT DROP
$IPT -P FORWARD DROP

###############################################################################
#
# Bruger-angivet Kæder
#
# Skabe bruger kæder til at reducere antallet af regler hver pakke skal krydse.

echo "Opret og befolke brugerdefineret regel kæder ..."

# Oprette en kæde til at filtrere UGYLDIGE (INVALID) pakker
$IPT -N bad_packets

# Opret en anden kæde til at filtrere dårlige TCP-pakker
$IPT -N bad_tcp_packets

# Opret separate kæder til ICMP, tcp (indgående og udgående), og indkommende
# UDP-pakker.
$IPT -N icmp_packets

# Bruges til UDP-pakker indgående fra internettet
$IPT -N udp_inbound

# Bruges til UDP-pakker indgående fra internettet
$IPT -N udp_outbound

# Bruges til at blokere udgående UDP tjenester fra interne netværk
# Standard at give alle
$IPT -N tcp_inbound

# Bruges til at blokere udgående flyvninger fra interne netværk
# Standard at give alle
$IPT -N tcp_outbound

###############################################################################
#
# Befolke Bruger Kæder
#

###############################################################################
#
# bad_packets kæde
#
<?php
	// Rules for the private network
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $GATEWAY )
		? "
# Drop modtagne pakker på den eksterne grænseflade
# hævder en kilde til det lokale netværk
\$IPT -A bad_packets -p ALL -i \$INET_IFACE -s \$LOCAL_NET -j LOG \
".		(( $LOG_FIREPARSE )
			? "    --log-prefix \"fp=bad_packets:2 a=DROP \""
			: "    --log-prefix \"Illegal source: \""
		). "

\$IPT -A bad_packets -p ALL -i \$INET_IFACE -s \$LOCAL_NET -j DROP
"
		: '';
?>

# Drop ugyldige (INVALID) pakker straks
$IPT -A bad_packets -p ALL -m state --state INVALID -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_packets:1 a=DROP \""
		: "    --log-prefix \"Invalid packet: \"";
?>


$IPT -A bad_packets -p ALL -m state --state INVALID -j DROP

# Så tjek de TCP-pakker for yderligere problemer
$IPT -A bad_packets -p tcp -j bad_tcp_packets

# Alle gode, så afkast
$IPT -A bad_packets -p ALL -j RETURN

###############################################################################
#
# bad_tcp_packets kæde
#
# Alle TCP-pakker vil krydse denne kæde.
# Hver ny forbindelse forsøg skal begynde med en SYN pakke. Hvis det
# ikke sker, er det sandsynligt en port scanning. Dette falder pakker
# i staten NY, der ikke er markeret som SYN pakker.

<?php
	// If there is a gateway, exempt the internal interface.
	print ( $GATEWAY )
		? "
# Vend tilbage til den kaldende kæden, hvis de dårlige pakker stammer
# fra den lokale grænseflade. Dette bevarer tilgangen i hele denne firewall
# et stort set betroet interne netværk.
\$IPT -A bad_tcp_packets -p tcp -i \$LOCAL_IFACE -j RETURN

# Men jeg oprindeligt gjorde anvende dette filter til den forreste kæde for
# pakker, der stammer fra det interne netværk. Mens jeg ikke har endeligt
# fastlagt sin virkning, det ser ud til at have det interessant sideeffekt at
# blokere nogle af de ad-systemer. Tilsyneladende nogle ad systemer har
# browseren indlede en ny forbindelse, der ikke er markeret som en syn pakke
# at hente annoncen billedet. Hvis du ønsker at eksperimentere yderligere
# kommentere ovennævnte regel. Hvis du prøver det, kan du også ønsker at
# udkommentere reglen nedenfor. Det vil holde disse pakker fra at blive
# logget. Der er en masse af dem.
#\$IPT -A bad_tcp_packets -p tcp -i \$LOCAL_IFACE ! --syn -m state \\
#     --state NEW -j DROP
"
		: '';
?>

# 2014-03-22 tilføjet -AK
# Lov ærefuldt på andres vegne modtager TCP Sequence Number Prediction
# angreb (disse angreb er afhængige af falsk vært DROP ukendte SYN / ACK'er
# snarere end afvise dem).
# Se https://www.frozentux.net/iptables-tutorial/iptables-tutorial.html#SYNACKANDNEW
$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,ACK SYN,ACK \
    -m state --state NEW -j REJECT --reject-with tcp-reset

# Fix iptables træk så nye pakker med SYN bit frakoblet
# Se https://www.frozentux.net/iptables-tutorial/iptables-tutorial.html#NEWNOTSYN
$IPT -A bad_tcp_packets -p tcp ! --syn -m state --state NEW -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:1 a=DROP \""
		: "    --log-prefix \"New not syn: \"";
?>

$IPT -A bad_tcp_packets -p tcp ! --syn -m state --state NEW -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL NONE -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:2 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL NONE -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL ALL -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:3 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL ALL -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL FIN,URG,PSH -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:4 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL FIN,URG,PSH -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL SYN,RST,ACK,FIN,URG -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:5 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL SYN,RST,ACK,FIN,URG -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,RST SYN,RST -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:6 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,RST SYN,RST -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,FIN SYN,FIN -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:7 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,FIN SYN,FIN -j DROP

# Alle gode, så afkast
$IPT -A bad_tcp_packets -p tcp -j RETURN

###############################################################################
#
# icmp_packets kæde
#
# Denne kæde er for indgående (fra Internettet) ICMP kun pakker.
# Type 8 (Echo Request) accepteres ikke som standard. Aktivér det, hvis du vil
# have eksterne værter at være i stand til at nå dig. 11 (overskredet) er den
# eneste accepterede, der ikke ville allerede være omfattet af den etablerede
# forbindelse reglen. Anvendt på INPUT på den eksterne grænseflade.
#
# Se: http://www.ee.siue.edu/~rwalden/networking/icmp.html
# for mere info om ICMP-typer.
#
# Bemærk, at de stateful indstillinger giver svar på ICMP-pakker.
# Disse regler tillader nye pakker af de specificerede typer.

# ICMP-pakker skal passe i en Layer 2 frame, således de bør aldrig være
# fragmenteret. Fragmenterede ICMP-pakker er et typisk tegn på en
# denial of service angreb.
$IPT -A icmp_packets --fragment -p ICMP -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=icmp_packets:1 a=DROP \""
		: "    --log-prefix \"ICMP Fragment: \"";
?>

$IPT -A icmp_packets --fragment -p ICMP -j DROP

# Echo; uncomment at give dit system til at blive pinged.
# Afkommentér LOG kommando, hvis du også ønsker at logge PING forsøg
#
# $IPT -A icmp_packets -p ICMP -s 0/0 --icmp-type 8 -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "#    --log-prefix \"fp=icmp_packets:2 a=ACCEPT \""
		: "#    --log-prefix \"Ping detected: \"";
?>

# $IPT -A icmp_packets -p ICMP -s 0/0 --icmp-type 8 -j ACCEPT

# Men som standard, drop pings uden logning. Blaster og andre orme har
# inficeret systemer sprængning pings. Kommentar linjen nedenfor, hvis
# du vil have pings logget, men det vil sandsynligvis fylde dine logs.
$IPT -A icmp_packets -p ICMP -s 0/0 --icmp-type 8 -j DROP

# Overskredet
$IPT -A icmp_packets -p ICMP -s 0/0 --icmp-type 11 -j ACCEPT

# Ikke matches, så vende tilbage, så det bliver logget
$IPT -A icmp_packets -p ICMP -j RETURN

###############################################################################
#
# TCP & UDP
# Identify ports at:
#    http://www.chebucto.ns.ca/~rakerman/port-table.html
#    http://www.iana.org/assignments/port-numbers

###############################################################################
#
# udp_inbound kæde
#
# Denne kæde beskriver de indgående UDP-pakker det vil acceptere.
# Det er anvendt på INPUT på den eksterne eller Internet interface.
# Bemærk, at de stateful indstillinger giver svar.
# Disse regler er for nye anmodninger.
# Det falder NetBIOS pakker (Windows) umiddelbart uden logning.

# Drop NetBIOS opkald
# Bemærk, at disse regler ikke virkelig ændre den måde, firewall behandler
# NetBIOS forbindelser. Forbindelser fra localhost og interne interface
# (hvis en sådan findes) er accepteret som standard. Svarene fra internettet
# til anmodninger indledt af eller gennem firewallen er også accepteret som
# standard. For at komme her, ville pakkerne skal være en del af en ny
# anmodning modtaget af Internet interface. Du ville have til manuelt at
# tilføje regler til at acceptere disse. Jeg har tilføjet disse regler, fordi
# nogle netværksforbindelser, såsom dem via kabelmodem, har tendens til at
# blive fyldt med støj fra ubeskyttede Windows-maskiner. Disse regler droppe
# disse pakker hurtigt og uden at logge dem. Dette forhindrer dem gennemkører
# hele kæden og holder loggen fra at blive rodet med snakken fra Windows-systemer.
$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 137 -j DROP
$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 138 -j DROP

<?php
	// Reject ident requests. IRC User
	print ( $IRC_USER )
		? "
# IRC Ident anmodninger (havn 113), skal have en afvis (REJECT) reglen snarere
# end standard DROP reglen. Dette er minimumskravet for at undgå lange
# forsinkelser, mens der forbinder. Se også tcp_inbound reglen.
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 113 -j REJECT

# En mere sofistikeret konfiguration kunne acceptere ident anmodninger.
#\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 113 -j ACCEPT
".		(( $GATEWAY )
			? "
# Men hvis dette er en gateway, der maskerader / NAT til interne systemer og
# interne systemer ønsker at chatte, en simpel ændring af disse regler til at
# acceptere, vil ikke fungere. Den ident daemon på gatewayen bliver nødt til
# at vide, hvordan man håndterer anmodninger. Bestanden dæmonen i de fleste
# Linux-distributioner kan ikke gøre det. oidentd er en pakke, der kan.
# Se også: http://dev.ojnk.net/
"
			: ''
		)
		: '';

	// NTP server on gateway
	print ( $NTP_IN )
		? "
# Server Network Time Protocol (NTP)
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 123 -j ACCEPT
"
		: '';

	// DNS Server - TCP (most are UDP, so this could be disabled)
	print ( $DNS_IN )
		? "
# DNS-server
# Konfigurer server til at bruge port 53 som kilde port til anmodninger.
# Bemærk: hvis du kører en caching kun navneserver, der kun accepterer
# forespørgsler fra det private netværk eller localhost, kan du
# udkommentere denne linie.
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 53 -j ACCEPT

# Hvis du ikke forespørge source serveren til port 53, og du har problemer,
# udkommenter denne regel. Det specifikt tillader svar på forespørgsler
# indledt til en anden server fra en høj UDP-port. Stateful tilslutningsregler
# bør håndtere denne situation, selv om.
#\$IPT -A udp_inbound -p UDP -s 0/0 --source-port 53 -j ACCEPT
"
		: '';

	// mDNSResponder
	print ( $MDNSRESPONDER_IN )
		? "
# mDNSResponder
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 5353 -j ACCEPT
"
		: '';

	// If running a DHCP server on the Internet interface, allow the requests
	print ( $DHCP_IN )
		? "
# Ekstern DHCP-server
# Tillad DHCP klient anmodning pakker indgående fra eksternt netværk
\$IPT -A udp_inbound -p UDP -s 0/0 --source-port 68 --destination-port 67 \\
     -j ACCEPT
"
		: '';
	// If it's a dynamic address, set rule to allow inbound DHCP
	print ( $DYNAMIC_IP )
		? "
# Dynamisk Adresse
# Hvis DHCP, den oprindelige anmodning er en udsendelse. Det svar er ikke
# præcis matcher den udgående pakke. Følgende tillader udtrykkeligt DHCP-porte
# til at afhjælpe dette problem. Hvis du modtager dit dynamiske adresse af en
# anden måde, kan du sikkert kommentere denne linje.
\$IPT -A udp_inbound -p UDP -s 0/0 --source-port 67 --destination-port 68 \\
     -j ACCEPT
"
		: '';

	// Inbound NFS selected
	print ( $NFS_IN )
		? "
# Server Network File System (NFS)
# Bemærk, at yderligere tjenester skal konfigureres for at støtte en NFS-server
# gennem firewallen. Læs hjælpen i generatoren eller dette site:
# http://www.lowth.com/LinWiz/nfs_help.html

# NFS-Server - portmapper
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 111 -j ACCEPT

# NFS-Server - statd
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $STATD_PORT -j ACCEPT

# NFS-Server - NFS daemon
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 2049 -j ACCEPT

# NFS-Server - lockd
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $LOCKD_PORT -j ACCEPT

# NFS-Server - mountd
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $MOUNTD_PORT -j ACCEPT

# NFS-Server - quotad
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $RQUOTAD_PORT -j ACCEPT
"
		: '';

	// User specified inbound rule
	print ( $OTHER_IN and $OTHER_IN_UDP )
		? "
# Bruger specificeret tilladt UDP-protokollen
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $OTHER_IN_FROM".
(( empty( $OTHER_IN_TO )) ? '' : ":$OTHER_IN_TO")." -j ACCEPT
"
		: '';
?>

# Ikke matches, så vende tilbage til logning
$IPT -A udp_inbound -p UDP -j RETURN

###############################################################################
#
# udp_outbound kæde
#
# Denne kæde bruges sammen med et privat netværk til at forhindre
# videresendelse til UDP forespørgsler om specifikke protokoller. Anvendt på
# den frem (FORWARD) regel fra det interne netværk. Slutter med en ACCEPT

<?php
	// If IM blocked, block ICQ, which uses UDP 4000
	print ( $IM_OUT )
		? "
# ICQ bruger UDP 4000 - Instant messaging spærret
\$IPT -A udp_outbound -p UDP -s 0/0 --destination-port 4000 -j REJECT
"
		: '';
?>

# Ingen match, så ACCEPT
$IPT -A udp_outbound -p UDP -s 0/0 -j ACCEPT

###############################################################################
#
# tcp_inbound kæde
#
# Denne kæde bruges til at tillade indgående forbindelser til system / gateway.
# Anvendes med forsigtighed. Det standard NONE. Det er anvendt på input fra
# eksterne / Internet interface.

<?php
	// allow own IP/CIDR through
print ( $SELF_IN )
	? "
# Tillade sig igennem (en statisk IP / CIDR er bedst)
# For at indsnævre adgangen tilladt, uncomment denne regel og kommentere det
# INPUT reglen (Derefter tilføje eller slette porte efter behov)
#\$IPT -A tcp_inbound -p TCP -s \$MY_CIDR -m multiport --destination-ports 21,22 -j ACCEPT
"
	: '';

	// Reject ident requests. IRC User
	print ( $IRC_USER )
		? "
# IRC Ident anmodninger (havn 113), skal have en AFVIS reglen snarere end
# standard DROP reglen. Dette er minimumskravet for at undgå lange
# forsinkelser, mens der forbinder. Se også udp_inbound reglen.
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 113 -j REJECT

# En mere sofistikeret konfiguration kunne acceptere ident anmodninger.
#\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 113 -j ACCEPT
".		(( $GATEWAY )
			? "
# Men hvis dette er en gateway, der maskerader / NAT til interne systemer
# og interne systemer ønsker at chatte, en simpel ændring af disse regler til
# at acceptere, vil ikke fungere. Den ident daemon på gatewayen bliver nødt
# til at vide, hvordan man håndterer anmodninger. Bestanden dæmonen i de fleste
# Linux-distributioner kan ikke gøre det. oidentd er en pakke, der kan.
# Se også: http://dev.ojnk.net/
"
			: ''
		)
		: '';

//DNS Server - TCP (most are UDP, so this could be disabled)
	print ( $DNS_IN )
		? "
# DNS-server - Tillad TCP-forbindelser (zoneoverførsler og store anmodninger)
# Dette er som standard deaktiveret. DNS Zone overførsler ske via TCP. Hvis du
# har brug for at tillade overførsler over nettet, du har brug for at
# udkommenter denne linje. Hvis du tillader forespørgsler fra 'net, skal du
# også være opmærksom på, at selv om DNS-forespørgsler bruge UDP som standard,
# en afkortet UDP forespørgsel lovligt kan indsendes via TCP i stedet. Du vil
# sandsynligvis aldrig brug for det, men bør være opmærksomme på det faktum.
# \$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 53 -j ACCEPT
"
		: '';

	// mDNSResponder
	print ( $MDNSRESPONDER_IN )
		? "
# mDNSResponder
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 5353 -j ACCEPT
"
		: '';

	// HTTP
	print ( $HTTP_IN )
		? "
# HTTP Webserver
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 80 -j ACCEPT
"
		: '';

	// HTTPS
	print ( $HTTPSSL_IN )
		? "
# HTTPS (Secure Web Server)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 443 -j ACCEPT
"
		: '';

	if( $FTP_IN ) {
		// FTP
		print "
# FTP-Server (Control)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 21 -j ACCEPT

# FTP-Klient (dataport for ikke-PASV overførsler)
\$IPT -A tcp_inbound -p TCP -s 0/0 --source-port 20 -j ACCEPT

# Passiv FTP
#
# Med passiv FTP, serveren giver en port til kunden og giver kunden mulighed
# for at starte forbindelsen stedet for at indlede forbindelse med klienten fra
# data port. Webbrowsere og kunder, der opererer bag en firewall generelt
# bruge passiv FTP overførsler. En generel formål FTP-server bliver nødt
# til at støtte dem.
#
# Men som standard en FTP-server, vil vælge en port fra hele spektret af høje
# porte. Det er ikke særlig sikkert at åbne alle høje porte. Heldigvis kan
# dette interval begrænses. Denne firewall forudsætter, at området er blevet
# begrænset til et bestemt markerede område. Dette interval skal også
# konfigureres i ftp-server.
#
# Instruktioner til angivelse af portintervallet til wu-ftpd-serveren kan
# findes her:
# http://www.wu-ftpd.org/man/ftpaccess.html
# (Se passive porte mulighed.)
#
# Instruktioner til ProFTPD serveren kan findes her:
# http://proftpd.linux.co.uk/localsite/Userguide/linked/x861.html
";

		// Passive FTP
		print ( $PASSIVE_IN )
			? "
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $PASSIVE_PORT_FROM:$PASSIVE_PORT_TO -j ACCEPT
"
			: "
# Sample regel
# \$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 62000:64000 -j ACCEPT
";
	}

	// Email
	print ( $EMAIL_IN )
		? "
# E-mail-Server (SMTP)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 25 -j ACCEPT

# E-mail-Server (POP3)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 110 -j ACCEPT

# E-mail-Server (IMAP4)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 143 -j ACCEPT
"
		: '';

	print ( $EMAILSSL_IN )
		? "
# SSL Email Server (POP3)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 995 -j ACCEPT

# SSL E-mail-Server (IMAP4)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 993 -j ACCEPT
"
		: '';

	// SSH
	print ( $SSH_IN )
		? "
# SSH
# MH hjælp: som leveret, den næste linje tillader ssh forbindelser fra enhver
# kilde ('-s 0/0'). Det vil føre til hundredvis af daglige forbindelser fra
# IP'er forsøger ordbogsangreb på din enhed. Hvis det overhovedet er muligt,
# anbefales du kraftigt at placere din egen IP / CIDR der i stedet:
# fx '-s \$MY_IP' eller '-s \$MY_CIDR'.
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 22 -j ACCEPT
"
		: '';

	// ICQ
	print ( $IM_IN )
		? "
# ICQ filoverførsler og andre avancerede funktioner
#
# ICQ understøtter en række muligheder ud over simpel instant messaging. For
# dem til at fungere, skal det instant messaging-system tillader nye
# forbindelser, der startes fra eksterne systemer. Denne mulighed vil åbne en
# specificeret portinterval på med firewall system. Den ICQ-klienten på med
# firewall-systemet skal også konfigureres til at bruge den angivne portinterval.
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $IM_PORT_FROM:$IM_PORT_TO -j ACCEPT
"
		: '';

	// MSN Messenger
	print ( $MESSENGER_IN )
		? "
# MSN Messenger Filoverførsler
#
# Messenger understøtter filoverførsler. Ved overførsler initieret af eksterne
# systemer til at fungere, skal systemet give nye forbindelser, der startes fra
# eksterne systemer en specifik portinterval. Denne indstilling er som standard
# portintervallet 6891 gennem 6900. Medmindre MSN Messenger-klient kan
# konfigureres til at specificere enhver portinterval, ikke ændre standard.
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $MSN_PORT_FROM:$MSN_PORT_TO -j ACCEPT
"
		: '';

	// Inbound NFS selected
	print ( $NFS_IN )
		? "
# Server Network File System (NFS)
#
# Bemærk, at yderligere tjenester skal konfigureres for at støtte en NFS-server
# gennem firewallen. Læs hjælpen i generatoren eller dette site:
# http://www.lowth.com/LinWiz/nfs_help.html

# NFS-Server - portmapper
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 111 -j ACCEPT

# NFS-Server - statd
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $STATD_PORT -j ACCEPT

# NFS-Server - NFS daemon
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 2049 -j ACCEPT

# NFS-Server - lockd
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $LOCKD_PORT -j ACCEPT

# NFS-Server - mountd
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $MOUNTD_PORT -j ACCEPT

# NFS-Server - quotad
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $RQUOTAD_PORT -j ACCEPT
"
		: '';

	// User specified inbound rule
	print ( $OTHER_IN and $OTHER_IN_TCP )
		? "
# Bruger specificeret tilladt TCP-protokollen
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port  $OTHER_IN_FROM".
(( empty( $OTHER_IN_TO )) ? '' : ":$OTHER_IN_TO")." -j ACCEPT
"
		: '';
?>

# Ikke matches, så vende tilbage, så det bliver logget
$IPT -A tcp_inbound -p TCP -j RETURN

###############################################################################
#
# tcp_outbound kæde
#
# Denne kæde bruges sammen med et privat netværk til at forhindre
# videresendelse for anmodninger om specifikke protokoller. Anvendt på den
# frem (FORWARD) regel fra det interne netværk. Slutter med en ACCEPT

<?php
	// IRC
	print ( $IRC_OUT )
		? "
# Block IRC
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 194 -j REJECT
"
		: '';

	// telnet
	print ( $TELNET_OUT )
		? "
# Bloker udgående Telnet
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 23 -j REJECT
"
		: '';

	// ssh
	print ( $SSH_OUT )
		? "
# Block SSH
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 22 -j REJECT
"
		: '';

	// usenet
	print ( $NEWS_OUT )
		? "
# Block Usenet Access
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 119 -j REJECT
"
		: '';

	// web
	print ( $HTTP_OUT )
		? "
# Block Web Access
# HTTP
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 80 -j REJECT

# HTTPS (Secure Web)
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 443 -j REJECT
"
		: '';

	// ftp
	print ( $FTP_OUT )
		? "
# Block FTP Access
# Control
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 21 -j REJECT

# Data
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 20 -j REJECT
"
		: '';

	// Instant Messaging
	print ( $IM_OUT )
		? "
# Block Instant Messaging
# AIM
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 5190 -j REJECT

# AIM Images
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 4443 -j REJECT

# MSN Messenger
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 1863 -j REJECT
"
		: '';

	// Instant Messaging
	print ( $EMAIL_OUT )
		? "
# Bloker e-mail adgang til eksterne servere
# SMTP
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 25 -j REJECT

# POP3
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 110 -j REJECT

# IMAP4
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 143 -j REJECT
"
		: '';
?>

# Ingen match, så ACCEPT
$IPT -A tcp_outbound -p TCP -s 0/0 -j ACCEPT

###############################################################################
#
# INPUT Kæde
#

echo "Proces INPUT kæde ..."

# Tillad alle på localhost-grænsefladen
$IPT -A INPUT -p ALL -i $LO_IFACE -j ACCEPT

# Drop dårlige pakker
$IPT -A INPUT -p ALL -j bad_packets

# DOCSIS kompatible kabelmodem
# Nogle DOCSIS kompatible kabelmodem sende IGMP multicast at finde tilsluttede
# pc'er. De multicast-pakker har den destination adresse 224.0.0.1. Du kan
# acceptere dem. Hvis du vælger at gøre det, afkommentere regel at acceptere
# dem og kommentere den regel at slippe dem Firewallen vil slippe dem her som
# standard for at undgå rod loggen. Firewallen vil frafalde alle multicasts til
# hele subnet (224.0.0.1) som standard. At det kun påvirker IGMP multicast,
# ændre '-p ALL' til '-p 2'. Selvfølgelig, hvis de ikke er andetsteds
# accepteres, det vil kun sikre, at multicasts på andre protokoller er logget.
# Drop dem uden logning.
$IPT -A INPUT -p ALL -d 224.0.0.1 -j DROP
# Reglen at acceptere pakker.
# $IPT -A INPUT -p ALL -d 224.0.0.1 -j ACCEPT

<?php
	if( $GATEWAY ) {
		// Rules for the private network
		print "
# Regler for det private netværk (adgang gateway selve systemet)
\$IPT -A INPUT -p ALL -i \$LOCAL_IFACE -s \$LOCAL_NET -j ACCEPT
\$IPT -A INPUT -p ALL -i \$LOCAL_IFACE -d \$LOCAL_BCAST -j ACCEPT
";

		// If running DHCP internally from this server, also allow dhcp client requests
		print ( $INTERNAL_DHCP )
			? "
# Tillad DHCP klient anmodning pakker indgående fra interne netværk
\$IPT -A INPUT -p UDP -i \$LOCAL_IFACE --source-port 68 --destination-port 67 \\
     -j ACCEPT
"
			: '';
	}
?>

# Indgående Internet Packet Regler

# Accepter etablerede forbindelser
$IPT -A INPUT -p ALL -i $INET_IFACE -m state --state ESTABLISHED,RELATED \
     -j ACCEPT

<?php
	// allow own IP/CIDR through
print ( $SELF_IN )
	? "
# Tillad sig igennem (en statisk IP / CIDR er bedst)
# Som leveret, denne regel giver adgang til alle porte til \$MY_CIDR
# For at indsnævre adgangen tilladt, kommentere denne regel & udkommenter
# tcp_inbound reglen
\$IPT -A INPUT -p TCP -s \$MY_CIDR   -j ACCEPT
"
	: '';

print ( $DICT )
	? "
# Stop ordbogsangreb:
# Dette stopper Ny forbindelse hastigheder på mere end 3/minute per IP
# (Derudover derefter krævede en 60 sek stille periode)
# De havne, der anvendes skal være identiske i alle 4 linjer under
# See: https://www.frozentux.net/iptables-tutorial/iptables-tutorial.html#RECENTMATCH
# See: http://forums.modem-help.co.uk/viewtopic.php?t=11438
\$IPT -A INPUT -p TCP -m tcp -m multiport --destination-ports 20,21,25,110,143 \
     -m state --state NEW -m recent --update \
     --seconds 60 --hitcount 4 --rttl -j DROP
\$IPT -A INPUT -p TCP -m tcp -m multiport --destination-ports 20,21,25,110,143 \
     -m state --state NEW -m recent --update \
     --seconds 60 --hitcount 3 --rttl -j LOG \
    --log-prefix \"Dictionary attack: \"
\$IPT -A INPUT -p TCP -m tcp -m multiport --destination-ports 20,21,25,110,143 \
     -m state --state NEW -m recent --update \
     --seconds 60 --hitcount 3 --rttl -j DROP
\$IPT -A INPUT -p TCP -m tcp -m multiport --destination-ports 20,21,25,110,143 \
     -m state --state NEW -m recent --set
"
	: '';
?>

# Rute resten til den relevante bruger kæden
$IPT -A INPUT -p TCP -i $INET_IFACE -j tcp_inbound
$IPT -A INPUT -p UDP -i $INET_IFACE -j udp_inbound
$IPT -A INPUT -p ICMP -i $INET_IFACE -j icmp_packets

# Drop zonder in te loggen uitzendingen die zo ver te komen.
# Bezuinigingen op log rommel. Geef commentaar op deze regel als het testen van
# nieuwe regels die van invloed zijn uitzending protocollen.
$IPT -A INPUT -m pkttype --pkt-type broadcast -j DROP

# Log pakker, der stadig ikke passer
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "
\$IPT -A INPUT -j LOG --log-prefix \"fp=INPUT:99 a=DROP \"
"
		: "
\$IPT -A INPUT -m limit --limit 3/minute --limit-burst 3 -j LOG \\
    --log-prefix \"INPUT packet died: \"
";
?>

###############################################################################
#
# FORWARD Kæde
#

echo "Processen fremad kæde ... "

# Bruges, hvis viderestilling til et privat netværk

<?php
	if( $GATEWAY ) {
		// private network exists
		print "
# Drop dårlige pakker
\$IPT -A FORWARD -p ALL -j bad_packets

# Accepter TCP-pakker, vi ønsker at sende fra interne kilder
\$IPT -A FORWARD -p tcp -i \$LOCAL_IFACE -j tcp_outbound

# Accepter UDP-pakker, vi ønsker at sende fra interne kilder
\$IPT -A FORWARD -p udp -i \$LOCAL_IFACE -j udp_outbound

# Hvis ikke er blokeret, acceptere andre pakker fra det interne interface
\$IPT -A FORWARD -p ALL -i \$LOCAL_IFACE -j ACCEPT

# Deal med svarene fra internettet
\$IPT -A FORWARD -i \$INET_IFACE -m state --state ESTABLISHED,RELATED \\
     -j ACCEPT

";

		// If port forwarding option selected, the forward chain must also
		// accept the port forwarding.
		// one/both of PORT_FORWARD_TCP and/or PORT_FORWARD_UDP *must* be selected
		print ( $PORT_FORWARD and $PORT_FORWARD_UDP )
			? "
# Havn Forwarding er aktiveret, så acceptere videresendt trafik
\$IPT -A FORWARD -p udp -i \$INET_IFACE --destination-port ".		(
				(( empty( $PORT_FORWARD_IPORT ))
					? ( $PORT_FORWARD_FROM . (( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO"))
					: $PORT_FORWARD_IPORT
				) ." \\\n     --destination $PORT_FORWARD_IP -j ACCEPT\n\n"
			)
			: '';

		print ( $PORT_FORWARD and $PORT_FORWARD_TCP )
			? "
\$IPT -A FORWARD -p tcp -i \$INET_IFACE --destination-port ".
			(
				(( empty( $PORT_FORWARD_IPORT ))
					? ( $PORT_FORWARD_FROM . (( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO"))
					: $PORT_FORWARD_IPORT
				) ." \\\n     --destination $PORT_FORWARD_IP -j ACCEPT\n\n"
			)
			: '';

		print "# Log pakker, der stadig ikke passer";

		// Check LOG_FIREPARSE to determine log-prefix format
		print ( $LOG_FIREPARSE )
			? "
\$IPT -A FORWARD -j LOG --log-prefix \"fp=FORWARD:99 a=DROP \"
"
			: "
\$IPT -A FORWARD -m limit --limit 3/minute --limit-burst 3 -j LOG \\
    --log-prefix \"FORWARD packet died: \"
";
	}
?>

###############################################################################
#
# OUTPUT Kæde
#

echo "Proces OUTPUT kæde ..."

# Generelt tillid firewall på udgang

# Brug ugyldige ICMP-pakker er dog til at være faldet for at forhindre en
# mulig udnytte.
$IPT -A OUTPUT -m state -p icmp --state INVALID -j DROP

# Localhost
$IPT -A OUTPUT -p ALL -s $LO_IP -j ACCEPT
$IPT -A OUTPUT -p ALL -o $LO_IFACE -j ACCEPT

<?php
	// If private network exists
	print ( $GATEWAY )
		? "
# Til interne netværk
\$IPT -A OUTPUT -p ALL -s \$LOCAL_IP -j ACCEPT
\$IPT -A OUTPUT -p ALL -o \$LOCAL_IFACE -j ACCEPT

"
		: '';
?>
# Til internet
$IPT -A OUTPUT -p ALL -o $INET_IFACE -j ACCEPT

# Log pakker, der stadig ikke passer
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "\$IPT -A OUTPUT -j LOG --log-prefix \"fp=OUTPUT:99 a=DROP \""
		: "\$IPT -A OUTPUT -m limit --limit 3/minute --limit-burst 3 -j LOG \\
    --log-prefix \"OUTPUT packet died: \"";
?>


###############################################################################
#
# NAT tabel
#
###############################################################################

# NAT tabel er hvor Network Address Translation opstår, hvis der er et privat netværk. Hvis gateway er forbundet til internettet med en statisk IP, er SNAT anvendes. Hvis gateway har en dynamisk adresse, skal maskerade anvendes i stedet. Der er mere overhead forbundet med maskerade, så snat er bedre, når det kan anvendes. NAT tabel har et indbygget kæde, PREROUTING for DNAT og omdirigeringer. En anden, POSTROUTING, håndtag SNAT og maskerade.

echo "Load regler for NAT tabel ..."

###############################################################################
#
# PREROUTING Kæde
#
<?php
	if( $PORT_FORWARD ) {
		// port forwarding option selected, build the rule here
		print "
# Port Forwarding

# Port Forwarding fremad al trafik på en port eller porte fra firewall til en
# computer på det interne LAN. Dette kan være forpligtet til at støtte særlige
# situationer. For eksempel, det er den eneste måde at støtte filoverførsler
# med en ICQ-klient på en intern computer. Det er også påkrævet, hvis et
# internt system er vært for en tjeneste som en webserver. Men det er også en
# farlig mulighed. Det giver internet-computere adgang til Deres interne
# netværk. Brug den omhyggeligt og kun hvis du er sikker på du ved hvad du gør.
";

		print ( $PORT_FORWARD_UDP )
			? "
\$IPT -t nat -A PREROUTING -p udp -i \$INET_IFACE --destination-port $PORT_FORWARD_FROM".
(( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO") ." \\
     -j DNAT --to-destination $PORT_FORWARD_IP".
(( empty( $PORT_FORWARD_IPORT )) ? '' : ":$PORT_FORWARD_IPORT")."
"
			: '';

		print ( $PORT_FORWARD_TCP )
			? "
\$IPT -t nat -A PREROUTING -p tcp -i \$INET_IFACE --destination-port $PORT_FORWARD_FROM".
(( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO") ." \\
     -j DNAT --to-destination $PORT_FORWARD_IP".
(( empty( $PORT_FORWARD_IPORT )) ? '' : ":$PORT_FORWARD_IPORT")."
"
			: '';

		print ( $PORT_FORWARD_REDIR and $PORT_FORWARD_UDP )
			? "
\$IPT -t nat -A PREROUTING -p udp -i \$LOCAL_IFACE --destination-port $PORT_FORWARD_FROM".
(( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO") ." \\
     --destination \$INET_ADDRESS -j DNAT --to-destination $PORT_FORWARD_IP".
(( empty( $PORT_FORWARD_IPORT )) ? '' : ":$PORT_FORWARD_IPORT")."
"
			: '';

		print ( $PORT_FORWARD_REDIR and $PORT_FORWARD_TCP )
			? "
\$IPT -t nat -A PREROUTING -p tcp -i \$LOCAL_IFACE --destination-port $PORT_FORWARD_FROM".
(( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO") ." \\
     --destination \$INET_ADDRESS -j DNAT --to-destination $PORT_FORWARD_IP".
(( empty( $PORT_FORWARD_IPORT )) ? '' : ":$PORT_FORWARD_IPORT")."
"
			: '';

		// If TRANSPARENT_PROXY option set, redirect port 80 and port 443 to the
		// REDIRECT_PORT on the gateway machine
		print ( $TRANSPARENT_PROXY )
			? "
# Dette er en prøve, der vil undtage en specifik vært fra transparent proxy
#\$IPT -t nat -A PREROUTING -p tcp -s 192.168.1.50 --destination-port 80 \\
#     -j RETURN
#\$IPT -t nat -A PREROUTING -p tcp -s 192.168.1.50 --destination-port 443 \\
#     -j RETURN

# Omdirigering HTTP for en transparent proxy
\$IPT -t nat -A PREROUTING -p tcp --destination-port 80 \\
     -j REDIRECT --to-ports $REDIRECT_PORT

# Omdiriger HTTPS til en transparent proxy - kommenteret af standard
# \$IPT -t nat -A PREROUTING -p tcp --destination-port 443 \\
#     -j REDIRECT --to-ports $REDIRECT_PORT
"
			: '';
	}
?>

###############################################################################
#
# POSTROUTING Kæde
#

<?php
	//If it's a gateway then install either snat or masquerade.
	print ( $GATEWAY )
		? (( $DYNAMIC_IP )	// masquerade or snat
			? "\$IPT -t nat -A POSTROUTING -o \$INET_IFACE -j MASQUERADE\n"
			: "\$IPT -t nat -A POSTROUTING -o \$INET_IFACE \\
     -j SNAT --to-source \$INET_ADDRESS\n".
			(( $PORT_FORWARD_REDIR )
				? "\$IPT -t nat -A POSTROUTING -o \$LOCAL_IFACE \\
     -j SNAT --to-source \$INET_ADDRESS
"
				: ''
			)
		)
		: '';
?>

###############################################################################
#
# mangle tabel
#
###############################################################################

# Den mangle tabel anvendes til at ændre pakker. Det kan ændre eller mangle dem
# på flere måder. Ved anvendelsen af ??denne generator, vi kun bruge sin evne
# til at ændre TTL i pakker. Imidlertid kan den anvendes til at indstille
# netfilter mark værdier specifikke pakker. Disse mærker kan derefter bruges i
# en anden tabel som filter, til at begrænse aktiviteterne i forbindelse med en
# bestemt vært, for eksempel. TOS målet kan bruges til at indstille den type
# service felt i IP-headeren. Bemærk, at TTL-målet ikke kunne medtages i
# fordelingen på dit system. Hvis det ikke er, og du har brug for det, bliver
# du nødt til at tilføje det. Det kan kræve, at du bygge fra kilden.

echo "Load regler for mangle bord ..."
<?php
	// Reset the TTL if requested to do so.
	print ( $MANGLE_TTL )
		? "
# Sæt TTL i udgående pakker til den samme konsekvente værdi. En værdi omkring
# 128 er en god værdi. Må ikke indstilles for højt, da det vil skade dit
# netværk. Det er også betragtes som dårlig form på internettet.
\$IPT -t mangle -A OUTPUT -o \$INET_IFACE -j TTL --ttl-set $TTL
"
		: '';
// vi: shiftwidth=3 tabstop=3 et
?>
